// Speed bin
// `define DDR3_800D   ; DDR3-800 (5-5-5)
// `define DDR3_800E   ; DDR3-800 (6-6-6)

// `define DDR3_1066E  ; DDR3-1066 (6-6-6)
// `define DDR3_1066F  ; DDR3-1066 (7-7-7)
// `define DDR3_1066G  ; DDR3-1066 (8-8-8)
// `define DDR3_1066G7 ; DDR3-1066 (7-7-7)

// `define DDR3_1333F  ; DDR3-1333 (7-7-7)
// `define DDR3_1333G  ; DDR3-1333 (8-8-8)
// `define DDR3_1333H  ; DDR3-1333 (9-9-9)
// `define DDR3_1333J  ; DDR3-1333 (10-10-10)

// `define DDR3_1600G  ; DDR3-1600 (8-8-8)
// `define DDR3_1600H  ; DDR3-1600 (9-9-9)
// `define DDR3_1600J  ; DDR3-1600 (10-10-10)
// `define DDR3_1600K  ; DDR3-1600 (11-11-11)

// `define DDR3_1866J  ; DDR3-1866 (10-10-10)
// `define DDR3_1866K  ; DDR3-1866 (11-11-11)
// `define DDR3_1866L  ; DDR3-1866 (12-12-12)
// `define DDR3_1866M  ; DDR3-1866 (13-13-13)

// `define DDR3_2133K  ; DDR3-2133 (11-11-11)
// `define DDR3_2133L  ; DDR3-2133 (12-12-12)
// `define DDR3_2133M  ; DDR3-2133 (13-13-13)
// `define DDR3_2133N  ; DDR3-2133 (14-14-14)

`ifdef DDR3_800D                                // DDR3-800 (5-5-5)
  `define     tCK                    2500.0     // clock cycle time[ns]
  `define     tRCmin                50000.0     // row cycle time[ns]
  `define     tRCDmin               12500.0     // row address to column address delay[ns]
  `define     tRPmin                12500.0     // row precharge time[ns]
  `define     tRASmin               37500.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                 1175.0     // clock high-level width[ns]
  `define     tCHmax                 1325.0     // clock high-level width[ns]
  `define     tCLmin                 1175.0     // clock low-level width[ns]
  `define     tCLmax                 1325.0     // clock low-level width[ns]
  `define     tHPmin                 1000.0     // clock half period[ns]
  `define     tCKmin                 2500.0     // clock cycle time[ns]
  `define     tCKmax                 3300.0     // clock cycle time[ns]
  `define     tDHmin                  250.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  250.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  400.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -800.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  400.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                200.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 275.0     // DQ hold skew factor[ns]#
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                  0.38     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                  0.38     // DQS/DQSb output low time[tCK]
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               30000.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.4     // write preamble setup time[tCK]
  `define     tWPRESmax                 0.6     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.4     // write postamble[tCK]
  `define     tWPSTmax                  0.6     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                  1.1     // write preamble[tCK]
  `define     tIHmin                  375.0     // address and control input hold time[ns]
  `define     tISmin                  375.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                  1.1     // read preamble[tCK]
  `define     tRPSTmin                  0.4     // DQS, DQS# differential read postamble[tCK]
  `define     tRPSTmax                  0.6     // DQS, DQS# differential read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin               10000.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 4     // internal write to read command delay[tCK]
  `define     tRTPmin               10000.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      3     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin               10000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                9000.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_800E                                // DDR3-800 (6-6-6)
  `define     tCK                    2500.0     // clock cycle time[ns]
  `define     tRCmin                52500.0     // row cycle time[ns]
  `define     tRCDmin               15000.0     // row address to column address delay[ns]
  `define     tRPmin                15000.0     // row precharge time[ns]
  `define     tRASmin               37500.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                 1175.0     // clock high-level width[ns]
  `define     tCHmax                 1325.0     // clock high-level width[ns]
  `define     tCLmin                 1175.0     // clock low-level width[ns]
  `define     tCLmax                 1325.0     // clock low-level width[ns]
  `define     tHPmin                 1000.0     // clock half period[ns]
  `define     tCKmin                 2500.0     // clock cycle time[ns]
  `define     tCKmax                 3300.0     // clock cycle time[ns]
  `define     tDHmin                  250.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  250.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  400.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -800.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  400.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                200.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 275.0     // DQ hold skew factor[ns]#
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                  0.38     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                  0.38     // DQS/DQSb output low time[tCK]
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               30000.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.4     // write preamble setup time[tCK]
  `define     tWPRESmax                 0.6     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.4     // write postamble[tCK]
  `define     tWPSTmax                  0.6     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                  1.1     // write preamble[tCK]
  `define     tIHmin                  375.0     // address and control input hold time[ns]
  `define     tISmin                  375.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                  1.1     // read preamble[tCK]
  `define     tRPSTmin                  0.4     // DQS, DQS# differential read postamble[tCK]
  `define     tRPSTmax                  0.6     // DQS, DQS# differential read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin               10000.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 4     // internal write to read command delay[tCK]  
  `define     tRTPmin               10000.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      3     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin               10000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                9000.0     // Write Leveling output delay[ns]  
`endif

`ifdef DDR3_1066E                               // DDR3-1066 (6-6-6)
  `define     tCK                    1875.0     // clock cycle time[ns]
  `define     tRCmin                48750.0     // row cycle time[ns]
  `define     tRCDmin               11250.0     // row address to column address delay[ns]
  `define     tRPmin                11250.0     // row precharge time[ns]
  `define     tRASmin               37500.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  882.0     // clock high-level width[ns]
  `define     tCHmax                  994.0     // clock high-level width[ns] 
  `define     tCLmin                  882.0     // clock low-level width[ns]
  `define     tCLmax                  994.0     // clock low-level width[ns]
  `define     tHPmin                  750.0     // clock half period[ns]
  `define     tCKmin                 1876.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  200.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  200.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  300.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -600.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  300.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                150.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 210.0     // DQ hold skew factor[ns]#
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                  0.38     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                  0.38     // DQS/DQSb output low time[tCK]
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               22500.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  300.0     // address and control input hold time[ns]
  `define     tISmin                  300.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 4     // internal write to read command delay[tCK]  
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                7500.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                9000.0     // Write Leveling output delay[ns]
`endif
 
`ifdef DDR3_1066F                               // DDR3-1066 (7-7-7)
  `define     tCK                    1875.0     // clock cycle time[ns]
  `define     tRCmin                50625.0     // row cycle time[ns]
  `define     tRCDmin               13125.0     // row address to column address delay[ns]
  `define     tRPmin                13125.0     // row precharge time[ns]
  `define     tRASmin               37500.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  882.0     // clock high-level width[ns]
  `define     tCHmax                  994.0     // clock high-level width[ns] 
  `define     tCLmin                  882.0     // clock low-level width[ns]
  `define     tCLmax                  994.0     // clock low-level width[ns]
  `define     tHPmin                  750.0     // clock half period[ns]
  `define     tCKmin                 1876.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  200.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  200.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  300.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -600.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  300.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                150.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 210.0     // DQ hold skew factor[ns]#
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                  0.38     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                  0.38     // DQS/DQSb output low time[tCK]
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               22500.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  300.0     // address and control input hold time[ns]
  `define     tISmin                  300.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 4     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                7500.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                9000.0     // Write Leveling output delay[ns]
`endif


`ifdef DDR3_1066G                               // DDR3-1066 (8-8-8)
  `define     tCK                    1875.0     // clock cycle time[ns]
  `define     tRCmin                52500.0     // row cycle time[ns]
  `define     tRCDmin               15000.0     // row address to column address delay[ns]
  `define     tRPmin                15000.0     // row precharge time[ns]
  `define     tRASmin               37500.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  882.0     // clock high-level width[ns]
  `define     tCHmax                  994.0     // clock high-level width[ns] 
  `define     tCLmin                  882.0     // clock low-level width[ns]
  `define     tCLmax                  994.0     // clock low-level width[ns]
  `define     tHPmin                  750.0     // clock half period[ns]
  `define     tCKmin                 1876.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  200.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  200.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  300.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -600.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  300.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                150.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 210.0     // DQ hold skew factor[ns]#
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                  0.38     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                  0.38     // DQS/DQSb output low time[tCK]
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               22500.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  300.0     // address and control input hold time[ns]
  `define     tISmin                  300.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 4     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                7500.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                9000.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1066G7                              // DDR3-1066 (7-7-7)
  `define     tCK                    1875.0     // clock cycle time[ns]
  `define     tRCmin                50625.0     // row cycle time[ns]
  `define     tRCDmin               13125.0     // row address to column address delay[ns]
  `define     tRPmin                13125.0     // row precharge time[ns]
  `define     tRASmin               37500.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.16     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.16     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  882.0     // clock high-level width[ns]
  `define     tCHmax                  994.0     // clock high-level width[ns] 
  `define     tCLmin                  882.0     // clock low-level width[ns]
  `define     tCLmax                  994.0     // clock low-level width[ns]
  `define     tHPmin                  750.0     // clock half period[ns]
  `define     tCKmin                 1876.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  200.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  200.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  300.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -600.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  300.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                150.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 210.0     // DQ hold skew factor[ns]#
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                  0.38     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                  0.38     // DQS/DQSb output low time[tCK]
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               22500.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  300.0     // address and control input hold time[ns]
  `define     tISmin                  300.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 4     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                7500.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                9000.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1333F                               // DDR3-1333 (7-7-7)
  `define     tCK                    1500.0     // clock cycle time[ns]
  `define     tRCmin                46500.0     // row cycle time[ns]
  `define     tRCDmin               10500.0     // row address to column address delay[ns]
  `define     tRPmin                10500.0     // row precharge time[ns]
  `define     tRASmin               36000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.17     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.17     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.17     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.17     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  645.0     // clock high-level width[ns]
  `define     tCHmax                  795.0     // clock high-level width[ns]
  `define     tCLmin                  645.0     // clock low-level width[ns]
  `define     tCLmax                  795.0     // clock low-level width[ns]
  `define     tHPmin                  600.0     // clock half period[ns]
  `define     tCKmin                 1500.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  180.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  165.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  250.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -500.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  250.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                125.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 100.0     // DQ hold skew factor[ns]#
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK]
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               18000.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  240.0     // address and control input hold time[ns]
  `define     tISmin                  240.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 5     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     4     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                6000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                9000.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1333G                               // DDR3-1333 (8-8-8)
  `define     tCK                    1500.0     // clock cycle time[ns]
  `define     tRCmin                48000.0     // row cycle time[ns]
  `define     tRCDmin               12000.0     // row address to column address delay[ns]
  `define     tRPmin                12000.0     // row precharge time[ns]
  `define     tRASmin               36000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.17     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.17     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.17     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.17     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  645.0     // clock high-level width[ns]
  `define     tCHmax                  795.0     // clock high-level width[ns]
  `define     tCLmin                  645.0     // clock low-level width[ns]
  `define     tCLmax                  795.0     // clock low-level width[ns]
  `define     tHPmin                  600.0     // clock half period[ns]
  `define     tCKmin                 1500.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  180.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  165.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  250.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -500.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  250.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                125.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 100.0     // DQ hold skew factor[ns]#
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK]
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               18000.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  240.0     // address and control input hold time[ns]
  `define     tISmin                  240.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 5     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     4     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                6000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                9000.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1333H                               // DDR3-1333 (9-9-9)
  `define     tCK                    1500.0     // clock cycle time[ns]
  `define     tRCmin                49500.0     // row cycle time[ns]
  `define     tRCDmin               13500.0     // row address to column address delay[ns]
  `define     tRPmin                13500.0     // row precharge time[ns]
  `define     tRASmin               36000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.17     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.17     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.17     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.17     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  645.0     // clock high-level width[ns]
  `define     tCHmax                  795.0     // clock high-level width[ns]
  `define     tCLmin                  645.0     // clock low-level width[ns]
  `define     tCLmax                  795.0     // clock low-level width[ns]
  `define     tHPmin                  600.0     // clock half period[ns]
  `define     tCKmin                 1500.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  180.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  165.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  250.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -500.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  250.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                125.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 100.0     // DQ hold skew factor[ns]#
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK]
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               18000.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  240.0     // address and control input hold time[ns]
  `define     tISmin                  240.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 5     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     4     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                6000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                9000.0     // Write Leveling output delay[ns]
`endif
 
`ifdef DDR3_1333J                               // DDR3-1333 (10-10-10)
  `define     tCK                    1500.0     // clock cycle time[ns]
  `define     tRCmin                51000.0     // row cycle time[ns]
  `define     tRCDmin               15000.0     // row address to column address delay[ns]
  `define     tRPmin                15000.0     // row precharge time[ns]
  `define     tRASmin               36000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.17     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.17     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.17     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.17     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  645.0     // clock high-level width[ns]
  `define     tCHmax                  795.0     // clock high-level width[ns]
  `define     tCLmin                  645.0     // clock low-level width[ns]
  `define     tCLmax                  795.0     // clock low-level width[ns]
  `define     tHPmin                  600.0     // clock half period[ns]
  `define     tCKmin                 1500.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  180.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  165.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  250.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -500.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  250.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                125.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 100.0     // DQ hold skew factor[ns]#
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK]
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               18000.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  240.0     // address and control input hold time[ns]
  `define     tISmin                  240.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 5     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     4     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                6000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                9000.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1600G                               // DDR3-1600 (8-8-8)
  `define     tCK                    1250.0     // clock cycle time[ns]
  `define     tRCmin                45000.0     // row cycle time[ns]
  `define     tRCDmin               10000.0     // row address to column address delay[ns]
  `define     tRPmin                10000.0     // row precharge time[ns]
  `define     tRASmin               35000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.18     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.18     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.18     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.18     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  537.0     // clock high-level width[ns]
  `define     tCHmax                  663.0     // clock high-level width[ns]
  `define     tCLmin                  537.0     // clock low-level width[ns]
  `define     tCLmax                  663.0     // clock low-level width[ns]
  `define     tHPmin                  500.0     // clock half period[ns]
  `define     tCKmin                 1250.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  160.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  145.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  225.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -450.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  225.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                100.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 100.0     // DQ hold skew factor[ns]#TBD
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               15000.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  220.0     // address and control input hold time[ns]
  `define     tISmin                  220.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 6     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     4     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                6000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1600H                               // DDR3-1600 (9-9-9)
  `define     tCK                    1250.0     // clock cycle time[ns]
  `define     tRCmin                46250.0     // row cycle time[ns]
  `define     tRCDmin               11250.0     // row address to column address delay[ns]
  `define     tRPmin                11250.0     // row precharge time[ns]
  `define     tRASmin               35000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.18     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.18     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.18     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.18     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  537.0     // clock high-level width[ns]
  `define     tCHmax                  663.0     // clock high-level width[ns]
  `define     tCLmin                  537.0     // clock low-level width[ns]
  `define     tCLmax                  663.0     // clock low-level width[ns]
  `define     tHPmin                  500.0     // clock half period[ns]
  `define     tCKmin                 1250.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  160.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  145.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  225.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -450.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  225.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                100.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 100.0     // DQ hold skew factor[ns]#TBD
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               15000.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  220.0     // address and control input hold time[ns]
  `define     tISmin                  220.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 6     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     4     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                6000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1600J                               // DDR3-1600 (10-10-10)
  `define     tCK                    1250.0     // clock cycle time[ns]
  `define     tRCmin                47500.0     // row cycle time[ns]
  `define     tRCDmin               12500.0     // row address to column address delay[ns]
  `define     tRPmin                12500.0     // row precharge time[ns]
  `define     tRASmin               35000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.18     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.18     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.18     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.18     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  537.0     // clock high-level width[ns]
  `define     tCHmax                  663.0     // clock high-level width[ns]
  `define     tCLmin                  537.0     // clock low-level width[ns]
  `define     tCLmax                  663.0     // clock low-level width[ns]
  `define     tHPmin                  500.0     // clock half period[ns]
  `define     tCKmin                 1250.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  160.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  145.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  225.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -450.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  225.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                100.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 100.0     // DQ hold skew factor[ns]#TBD
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               15000.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  220.0     // address and control input hold time[ns]
  `define     tISmin                  220.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 6     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     4     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                6000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1600K                               // DDR3-1600 (11-11-11)
  `define     tCK                    1250.0     // clock cycle time[ns]
  `define     tRCmin                48750.0     // row cycle time[ns]
  `define     tRCDmin               13750.0     // row address to column address delay[ns]
  `define     tRPmin                13750.0     // row precharge time[ns]
  `define     tRASmin               35000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                  -0.18     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                   0.18     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin               -0.18     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax                0.18     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  537.0     // clock high-level width[ns]
  `define     tCHmax                  663.0     // clock high-level width[ns]
  `define     tCLmin                  537.0     // clock low-level width[ns]
  `define     tCLmax                  663.0     // clock low-level width[ns]
  `define     tHPmin                  500.0     // clock half period[ns]
  `define     tCKmin                 1250.0     // clock cycle time[ns]
  `define     tCKmax                 3333.0     // clock cycle time[ns]
  `define     tDHmin                  160.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  145.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                   0.6     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.35     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  225.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -450.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  225.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tDQSQmax                100.0     // DQS-DQ skew for DQS and associated DQ signals[ns]
  `define     tQHSmax                 100.0     // DQ hold skew factor[ns]#TBD
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.25)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                  0.4     // DQS input high pulse width[tCK]
  `define     tDQSHmax                  0.6     // DQS input high pulse width[tCK]
  `define     tDQSLmin                  0.4     // DQS input low pulse width[tCK]
  `define     tDQSLmax                  0.6     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                   0.2     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                   0.2     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               15000.0     // mode register set command update delay[ns]
  `define     tWPRESmin                 0.3     // write preamble setup time[tCK]
  `define     tWPRESmax                0.66     // write preamble setup time[tCK]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPSTmax                 0.66     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tWPREmax                 1.33     // write preamble[tCK]
  `define     tIHmin                  220.0     // address and control input hold time[ns]
  `define     tISmin                  220.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPREmax                 1.33     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tRPSTmax                 0.66     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 6     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     4     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      4     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                6000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1866J                               // DDR3-1866 (10-10-10)
  `define     tCK                    1070.0     // clock cycle time[ns]
  `define     tRCmin                44700.0     // row cycle time[ns]
  `define     tRCDmin               10700.0     // row address to column address delay[ns]
  `define     tRPmin                10700.0     // row precharge time[ns]
  `define     tRASmin               34000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                 -0.195     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                  0.195     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin              -0.195     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax               0.195     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  470.0     // clock high-level width[ns]
  `define     tCHmax                  530.0     // clock high-level width[ns]
  `define     tCLmin                  470.0     // clock low-level width[ns]
  `define     tCLmax                  530.0     // clock low-level width[ns]
  `define     tCKmin                 8000.0     // clock cycle time[ns]
  `define     tCKmax                 1070.0     // clock cycle time[ns]
  `define     tDHmin                  160.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  145.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                 0.535     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.32     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  195.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -390.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  195.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tQHSmax                  85.0     // DQ hold skew factor[ns]#TBD
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.27)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.27)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                 0.45     // DQS input high pulse width[tCK]
  `define     tDQSHmax                 0.55     // DQS input high pulse width[tCK]
  `define     tDQSLmin                 0.45     // DQS input low pulse width[tCK]
  `define     tDQSLmax                 0.55     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                  0.18     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                  0.18     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               15000.0     // mode register set command update delay[ns]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tIHmin                  220.0     // address and control input hold time[ns]
  `define     tISmin                  220.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 7     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      3     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                5000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1866K                               // DDR3-1866 (11-11-11)
  `define     tCK                    1070.0     // clock cycle time[ns]
  `define     tRCmin                45770.0     // row cycle time[ns]
  `define     tRCDmin               11770.0     // row address to column address delay[ns]
  `define     tRPmin                11770.0     // row precharge time[ns]
  `define     tRASmin               34000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                 -0.195     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                  0.195     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin              -0.195     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax               0.195     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  470.0     // clock high-level width[ns]
  `define     tCHmax                  530.0     // clock high-level width[ns]
  `define     tCLmin                  470.0     // clock low-level width[ns]
  `define     tCLmax                  530.0     // clock low-level width[ns]
  `define     tCKmin                 8000.0     // clock cycle time[ns]
  `define     tCKmax                 1070.0     // clock cycle time[ns]
  `define     tDHmin                  160.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  145.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                 0.535     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.32     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  195.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -390.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  195.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tQHSmax                  85.0     // DQ hold skew factor[ns]#TBD
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.27)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.27)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                 0.45     // DQS input high pulse width[tCK]
  `define     tDQSHmax                 0.55     // DQS input high pulse width[tCK]
  `define     tDQSLmin                 0.45     // DQS input low pulse width[tCK]
  `define     tDQSLmax                 0.55     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                  0.18     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                  0.18     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               15000.0     // mode register set command update delay[ns]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tIHmin                  220.0     // address and control input hold time[ns]
  `define     tISmin                  220.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 7     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      3     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                5000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1866L                               // DDR3-1866 (12-12-12)
  `define     tCK                    1070.0     // clock cycle time[ns]
  `define     tRCmin                46840.0     // row cycle time[ns]
  `define     tRCDmin               12840.0     // row address to column address delay[ns]
  `define     tRPmin                12840.0     // row precharge time[ns]
  `define     tRASmin               34000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                 -0.195     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                  0.195     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin              -0.195     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax               0.195     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  470.0     // clock high-level width[ns]
  `define     tCHmax                  530.0     // clock high-level width[ns]
  `define     tCLmin                  470.0     // clock low-level width[ns]
  `define     tCLmax                  530.0     // clock low-level width[ns]
  `define     tCKmin                 8000.0     // clock cycle time[ns]
  `define     tCKmax                 1070.0     // clock cycle time[ns]
  `define     tDHmin                  160.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  145.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                 0.535     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.32     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  195.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -390.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  195.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tQHSmax                  85.0     // DQ hold skew factor[ns]#TBD
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.27)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.27)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                 0.45     // DQS input high pulse width[tCK]
  `define     tDQSHmax                 0.55     // DQS input high pulse width[tCK]
  `define     tDQSLmin                 0.45     // DQS input low pulse width[tCK]
  `define     tDQSLmax                 0.55     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                  0.18     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                  0.18     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               15000.0     // mode register set command update delay[ns]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tIHmin                  220.0     // address and control input hold time[ns]
  `define     tISmin                  220.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 7     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      3     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                5000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_1866M                               // DDR3-1866 (13-13-13)
  `define     tCK                    1070.0     // clock cycle time[ns]
  `define     tRCmin                47910.0     // row cycle time[ns]
  `define     tRCDmin               13910.0     // row address to column address delay[ns]
  `define     tRPmin                13910.0     // row precharge time[ns]
  `define     tRASmin               34000.0     // active to precharge command[ns]
  `define     tRASmax            70000000.0     // active to precharge command[ns]
  `define     tACmin                 -0.195     // DQ output access time from CLK, CLKb[tCK]#
  `define     tACmax                  0.195     // DQ output access time from CLK, CLKb[tCK]#
  `define     tDQSCKmin              -0.195     // DQS output access time from CLK, CLKb[tCK]
  `define     tDQSCKmax               0.195     // DQS output access time from CLK, CLKb[tCK]
  `define     tCHmin                  470.0     // clock high-level width[ns]
  `define     tCHmax                  530.0     // clock high-level width[ns]
  `define     tCLmin                  470.0     // clock low-level width[ns]
  `define     tCLmax                  530.0     // clock low-level width[ns]
  `define     tCKmin                 8000.0     // clock cycle time[ns]
  `define     tCKmax                 1070.0     // clock cycle time[ns]
  `define     tDHmin                  160.0     // DQ and DM input hold time[ns]
  `define     tDSmin                  145.0     // DQ and DM input setup time[ns]
  `define     tIPWmin                 0.535     // control and address input pulse width for each input[tCK]
  `define     tDIPWmin                 0.32     // DQ and DM input pulse width for each input[tCK]
  `define     tHZmax                  195.0     // data-out high-impedance time from CLK, CLKb[ns]
  `define     tLZmin                 -390.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tLZmax                  195.0     // data-out low-impedance time from CLK, CLKb[ns]
  `define     tQHSmax                  85.0     // DQ hold skew factor[ns]#TBD
  `define     tQHmin                  0.380     // DQ/DQS output hold time from DQS[tCK]
  `define     tDQSSmin            (WL-0.27)     // write command to first DQS latching transition[tCK]
  `define     tDQSSmax            (WL+0.27)     // write command to first DQS latching transition[tCK]
  `define     tDQSHmin                 0.45     // DQS input high pulse width[tCK]
  `define     tDQSHmax                 0.55     // DQS input high pulse width[tCK]
  `define     tDQSLmin                 0.45     // DQS input low pulse width[tCK]
  `define     tDQSLmax                 0.55     // DQS input low pulse width[tCK]
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK]
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                  0.18     // DQS falling edge to clock setup time[tCK]
  `define     tDSHmin                  0.18     // DQS falling edge hold time from clock[tCK]
  `define     tMRDmin                     4     // mode register set command cycle time[tCK]
  `define     tMODmin               15000.0     // mode register set command update delay[ns]
  `define     tWPSTmin                  0.3     // write postamble[tCK]
  `define     tWPREmin                  0.9     // write preamble[tCK]
  `define     tIHmin                  220.0     // address and control input hold time[ns]
  `define     tISmin                  220.0     // address and control input setup time[ns]
  `define     tRPREmin                  0.9     // read preamble[tCK]
  `define     tRPSTmin                  0.3     // read postamble[tCK]
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK]
  `define     tWRmin                15000.0     // write recovery time[ns]
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK]
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns]
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK]
  `define     tXPmin                      3     // fast exit active/precharge power down to any command[tCK]
  `define     tRRDmin                5000.0     // active to active command period for 1KB page size products[ns]
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK]
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK]
  `define     tREFPDEN                    1     // Timing of last REFRESH command to power down entry[tCK]
  `define     tACTPDEN                    1     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_2133K                             // DDR3-2133 (11-11-11)
  `define     tCK                     938.0     // clock cycle time[ns] 
  `define     tRCmin                43285.0     // row cycle time[ns] 
  `define     tRCDmin               10285.0     // row address to column address delay[ns] 
  `define     tRPmin                10285.0     // row precharge time[ns] 
  `define     tRASmin               33000.0     // active to precharge command[ns] 
  `define     tRASmax            70000000.0     // active to precharge command[ns] 
  `define     tACmin                 -0.180     // DQ output access time from CLK, CLKb[tCK]# 
  `define     tACmax                  0.180     // DQ output access time from CLK, CLKb[tCK]# 
  `define     tDQSCKmin              -0.180     // DQS output access time from CLK, CLKb[tCK] 
  `define     tDQSCKmax               0.180     // DQS output access time from CLK, CLKb[tCK] 
  `define     tCHmin                  470.0     // clock high-level width[ns] 
  `define     tCHmax                  530.0     // clock high-level width[ns] 
  `define     tCLmin                  470.0     // clock low-level width[ns] 
  `define     tCLmax                  530.0     // clock low-level width[ns] 
  `define     tCKmin                 8000.0     // clock cycle time[ns] 
  `define     tCKmax                  938.0     // clock cycle time[ns] 
  `define     tDHmin                   50.0     // DQ and DM input hold time[ns] 
  `define     tDSmin                   68.0     // DQ and DM input setup time[ns] 
  `define     tIPWmin                 0.470     // control and address input pulse width for each input[tCK] 
  `define     tDIPWmin                0.280     // DQ and DM input pulse width for each input[tCK] 
  `define     tHZmax                  180.0     // data-out high-impedance time from CLK, CLKb[ns] 
  `define     tLZmin                 -360.0     // data-out low-impedance time from CLK, CLKb[ns] 
  `define     tLZmax                  180.0     // data-out low-impedance time from CLK, CLKb[ns] 
  `define     tDQSQmax                 75.0     // DQS-DQ skew for DQS and associated DQ signals[ns] 
  `define     tQHmin                   0.38     // DQ/DQS output hold time from DQS[tCK] 
  `define     tDQSSmin            (WL-0.27)     // write command to first DQS latching transition[tCK] 
  `define     tDQSSmax            (WL+0.27)     // write command to first DQS latching transition[tCK] 
  `define     tDQSHmin                 0.45     // DQS input high pulse width[tCK] 
  `define     tDQSHmax                 0.55     // DQS input high pulse width[tCK] 
  `define     tDQSLmin                 0.45     // DQS input low pulse width[tCK] 
  `define     tDQSLmax                 0.55     // DQS input low pulse width[tCK] 
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK] 
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                  0.18     // DQS falling edge to clock setup time[tCK] 
  `define     tDSHmin                  0.18     // DQS falling edge hold time from clock[tCK] 
  `define     tMRDmin                     4     // mode register set command cycle time[tCK] 
  `define     tMODmin               15000.0     // mode register set command update delay[ns] 
  `define     tWPSTmin                  0.3     // write postamble[tCK] 
  `define     tWPREmin                  0.9     // write preamble[tCK] 
  `define     tIHmin                   95.0     // address and control input hold time[ns] 
  `define     tISmin                   95.0     // address and control input setup time[ns] 
  `define     tRPREmin                  0.9     // read preamble[tCK] 
  `define     tRPSTmin                  0.3     // read postamble[tCK] 
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK] 
  `define     tWRmin                15000.0     // write recovery time[ns] 
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK] 
  `define     tWTRmin                7500.0     // internal write to read command delay[ns]
  `define     tWTRmin_tck                 8     // internal write to read command delay[tCK] 
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns] 
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK] 
  `define     tXPmin                      3     // fast exit active/precharge power down to any command[tCK] 
  `define     tRRDmin                4000.0     // active to active command period for 1KB page size products[ns] 
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK] 
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK] 
  `define     tREFPDEN                    2     // Timing of last REFRESH command to power down entry[tCK] 
  `define     tACTPDEN                    2     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_2133L                             // DDR3-2133 (12-12-12)
  `define     tCK                     938.0     // clock cycle time[ns] 
  `define     tRCmin                44220.0     // row cycle time[ns] 
  `define     tRCDmin               11220.0     // row address to column address delay[ns] 
  `define     tRPmin                11220.0     // row precharge time[ns] 
  `define     tRASmin               33000.0     // active to precharge command[ns] 
  `define     tRASmax            70000000.0     // active to precharge command[ns] 
  `define     tACmin                 -0.180     // DQ output access time from CLK, CLKb[tCK]# 
  `define     tACmax                  0.180     // DQ output access time from CLK, CLKb[tCK]# 
  `define     tDQSCKmin              -0.180     // DQS output access time from CLK, CLKb[tCK] 
  `define     tDQSCKmax               0.180     // DQS output access time from CLK, CLKb[tCK] 
  `define     tCHmin                  470.0     // clock high-level width[ns] 
  `define     tCHmax                  530.0     // clock high-level width[ns] 
  `define     tCLmin                  470.0     // clock low-level width[ns] 
  `define     tCLmax                  530.0     // clock low-level width[ns] 
  `define     tCKmin                 8000.0     // clock cycle time[ns] 
  `define     tCKmax                  938.0     // clock cycle time[ns] 
  `define     tDHmin                   50.0     // DQ and DM input hold time[ns] 
  `define     tDSmin                   68.0     // DQ and DM input setup time[ns] 
  `define     tIPWmin                 0.470     // control and address input pulse width for each input[tCK] 
  `define     tDIPWmin                0.280     // DQ and DM input pulse width for each input[tCK] 
  `define     tHZmax                  180.0     // data-out high-impedance time from CLK, CLKb[ns] 
  `define     tLZmin                 -360.0     // data-out low-impedance time from CLK, CLKb[ns] 
  `define     tLZmax                  180.0     // data-out low-impedance time from CLK, CLKb[ns] 
  `define     tDQSQmax                 75.0     // DQS-DQ skew for DQS and associated DQ signals[ns] 
  `define     tQHmin                   0.38     // DQ/DQS output hold time from DQS[tCK] 
  `define     tDQSSmin            (WL-0.27)     // write command to first DQS latching transition[tCK] 
  `define     tDQSSmax            (WL+0.27)     // write command to first DQS latching transition[tCK] 
  `define     tDQSHmin                 0.45     // DQS input high pulse width[tCK] 
  `define     tDQSHmax                 0.55     // DQS input high pulse width[tCK] 
  `define     tDQSLmin                 0.45     // DQS input low pulse width[tCK] 
  `define     tDQSLmax                 0.55     // DQS input low pulse width[tCK] 
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK] 
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                  0.18     // DQS falling edge to clock setup time[tCK] 
  `define     tDSHmin                  0.18     // DQS falling edge hold time from clock[tCK] 
  `define     tMRDmin                     4     // mode register set command cycle time[tCK] 
  `define     tMODmin               15000.0     // mode register set command update delay[ns] 
  `define     tWPSTmin                  0.3     // write postamble[tCK] 
  `define     tWPREmin                  0.9     // write preamble[tCK] 
  `define     tIHmin                   95.0     // address and control input hold time[ns] 
  `define     tISmin                   95.0     // address and control input setup time[ns] 
  `define     tRPREmin                  0.9     // read preamble[tCK] 
  `define     tRPSTmin                  0.3     // read postamble[tCK] 
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK] 
  `define     tWRmin                15000.0     // write recovery time[ns] 
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK] 
  `define     tWTRmin                7500.0     // internal write to read command delay[ns] 
  `define     tWTRmin_tck                 8     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns] 
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK] 
  `define     tXPmin                      3     // fast exit active/precharge power down to any command[tCK] 
  `define     tRRDmin                4000.0     // active to active command period for 1KB page size products[ns] 
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK] 
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK] 
  `define     tREFPDEN                    2     // Timing of last REFRESH command to power down entry[tCK] 
  `define     tACTPDEN                    2     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_2133M                             // DDR3-2133 (13-13-13)
  `define     tCK                     938.0     // clock cycle time[ns] 
  `define     tRCmin                45155.0     // row cycle time[ns] 
  `define     tRCDmin               12155.0     // row address to column address delay[ns] 
  `define     tRPmin                12155.0     // row precharge time[ns] 
  `define     tRASmin               33000.0     // active to precharge command[ns] 
  `define     tRASmax            70000000.0     // active to precharge command[ns] 
  `define     tACmin                 -0.180     // DQ output access time from CLK, CLKb[tCK]# 
  `define     tACmax                  0.180     // DQ output access time from CLK, CLKb[tCK]# 
  `define     tDQSCKmin              -0.180     // DQS output access time from CLK, CLKb[tCK] 
  `define     tDQSCKmax               0.180     // DQS output access time from CLK, CLKb[tCK] 
  `define     tCHmin                  470.0     // clock high-level width[ns] 
  `define     tCHmax                  530.0     // clock high-level width[ns] 
  `define     tCLmin                  470.0     // clock low-level width[ns] 
  `define     tCLmax                  530.0     // clock low-level width[ns] 
  `define     tCKmin                 8000.0     // clock cycle time[ns] 
  `define     tCKmax                  938.0     // clock cycle time[ns] 
  `define     tDHmin                   50.0     // DQ and DM input hold time[ns] 
  `define     tDSmin                   68.0     // DQ and DM input setup time[ns] 
  `define     tIPWmin                 0.470     // control and address input pulse width for each input[tCK] 
  `define     tDIPWmin                0.280     // DQ and DM input pulse width for each input[tCK] 
  `define     tHZmax                  180.0     // data-out high-impedance time from CLK, CLKb[ns] 
  `define     tLZmin                 -360.0     // data-out low-impedance time from CLK, CLKb[ns] 
  `define     tLZmax                  180.0     // data-out low-impedance time from CLK, CLKb[ns] 
  `define     tDQSQmax                 75.0     // DQS-DQ skew for DQS and associated DQ signals[ns] 
  `define     tQHmin                   0.38     // DQ/DQS output hold time from DQS[tCK] 
  `define     tDQSSmin            (WL-0.27)     // write command to first DQS latching transition[tCK] 
  `define     tDQSSmax            (WL+0.27)     // write command to first DQS latching transition[tCK] 
  `define     tDQSHmin                 0.45     // DQS input high pulse width[tCK] 
  `define     tDQSHmax                 0.55     // DQS input high pulse width[tCK] 
  `define     tDQSLmin                 0.45     // DQS input low pulse width[tCK] 
  `define     tDQSLmax                 0.55     // DQS input low pulse width[tCK] 
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK] 
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                  0.18     // DQS falling edge to clock setup time[tCK] 
  `define     tDSHmin                  0.18     // DQS falling edge hold time from clock[tCK] 
  `define     tMRDmin                     4     // mode register set command cycle time[tCK] 
  `define     tMODmin               15000.0     // mode register set command update delay[ns] 
  `define     tWPSTmin                  0.3     // write postamble[tCK] 
  `define     tWPREmin                  0.9     // write preamble[tCK] 
  `define     tIHmin                   95.0     // address and control input hold time[ns] 
  `define     tISmin                   95.0     // address and control input setup time[ns] 
  `define     tRPREmin                  0.9     // read preamble[tCK] 
  `define     tRPSTmin                  0.3     // read postamble[tCK] 
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK] 
  `define     tWRmin                15000.0     // write recovery time[ns] 
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK] 
  `define     tWTRmin                7500.0     // internal write to read command delay[ns] 
  `define     tWTRmin_tck                 8     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns] 
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK] 
  `define     tXPmin                      3     // fast exit active/precharge power down to any command[tCK] 
  `define     tRRDmin                4000.0     // active to active command period for 1KB page size products[ns] 
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK] 
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK] 
  `define     tREFPDEN                    2     // Timing of last REFRESH command to power down entry[tCK] 
  `define     tACTPDEN                    2     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

`ifdef DDR3_2133N                             // DDR3-2133 (14-14-14)
  `define     tCK                     938.0     // clock cycle time[ns] 
  `define     tRCmin                46090.0     // row cycle time[ns] 
  `define     tRCDmin               13090.0     // row address to column address delay[ns] 
  `define     tRPmin                13090.0     // row precharge time[ns] 
  `define     tRASmin               33000.0     // active to precharge command[ns] 
  `define     tRASmax            70000000.0     // active to precharge command[ns] 
  `define     tACmin                 -0.180     // DQ output access time from CLK, CLKb[tCK]# 
  `define     tACmax                  0.180     // DQ output access time from CLK, CLKb[tCK]# 
  `define     tDQSCKmin              -0.180     // DQS output access time from CLK, CLKb[tCK] 
  `define     tDQSCKmax               0.180     // DQS output access time from CLK, CLKb[tCK] 
  `define     tCHmin                  470.0     // clock high-level width[ns] 
  `define     tCHmax                  530.0     // clock high-level width[ns] 
  `define     tCLmin                  470.0     // clock low-level width[ns] 
  `define     tCLmax                  530.0     // clock low-level width[ns] 
  `define     tCKmin                 8000.0     // clock cycle time[ns] 
  `define     tCKmax                  938.0     // clock cycle time[ns] 
  `define     tDHmin                   50.0     // DQ and DM input hold time[ns] 
  `define     tDSmin                   68.0     // DQ and DM input setup time[ns] 
  `define     tIPWmin                 0.470     // control and address input pulse width for each input[tCK] 
  `define     tDIPWmin                0.280     // DQ and DM input pulse width for each input[tCK] 
  `define     tHZmax                  180.0     // data-out high-impedance time from CLK, CLKb[ns] 
  `define     tLZmin                 -360.0     // data-out low-impedance time from CLK, CLKb[ns] 
  `define     tLZmax                  180.0     // data-out low-impedance time from CLK, CLKb[ns] 
  `define     tDQSQmax                 75.0     // DQS-DQ skew for DQS and associated DQ signals[ns] 
  `define     tQHmin                   0.38     // DQ/DQS output hold time from DQS[tCK] 
  `define     tDQSSmin            (WL-0.27)     // write command to first DQS latching transition[tCK] 
  `define     tDQSSmax            (WL+0.27)     // write command to first DQS latching transition[tCK] 
  `define     tDQSHmin                 0.45     // DQS input high pulse width[tCK] 
  `define     tDQSHmax                 0.55     // DQS input high pulse width[tCK] 
  `define     tDQSLmin                 0.45     // DQS input low pulse width[tCK] 
  `define     tDQSLmax                 0.55     // DQS input low pulse width[tCK] 
  `define     tQSHmin                   0.4     // DQS/DQSb output high time[tCK] 
  `define     tQSLmin                   0.4     // DQS/DQSb output low time[tCK] 
  `define     tDSSmin                  0.18     // DQS falling edge to clock setup time[tCK] 
  `define     tDSHmin                  0.18     // DQS falling edge hold time from clock[tCK] 
  `define     tMRDmin                     4     // mode register set command cycle time[tCK] 
  `define     tMODmin               15000.0     // mode register set command update delay[ns] 
  `define     tWPSTmin                  0.3     // write postamble[tCK] 
  `define     tWPREmin                  0.9     // write preamble[tCK] 
  `define     tIHmin                   95.0     // address and control input hold time[ns] 
  `define     tISmin                   95.0     // address and control input setup time[ns] 
  `define     tRPREmin                  0.9     // read preamble[tCK] 
  `define     tRPSTmin                  0.3     // read postamble[tCK] 
  `define     tCCDmin                     4     // CAS to CAS command delay[tCK] 
  `define     tWRmin                15000.0     // write recovery time[ns] 
  `define     tDALmin     (`tWRmin+`tRPmin)     // auto precharge write recovery + precharge time[tCK] 
  `define     tWTRmin                7500.0     // internal write to read command delay[ns] 
  `define     tWTRmin_tck                 8     // internal write to read command delay[tCK]
  `define     tRTPmin                7500.0     // internal read to precharge command delay[ns] 
  `define     tCKEmin                     3     // CKE minimum pulse width(high and low pulse width)[tCK] 
  `define     tXPmin                      3     // fast exit active/precharge power down to any command[tCK] 
  `define     tRRDmin                4000.0     // active to active command period for 1KB page size products[ns] 
  `define     tXS                         5     // Exit self refesh to a non-read or write command[tCK] 
  `define     tXSDLL                    512     // Exit self refesh to a non-read or write command[tCK] 
  `define     tREFPDEN                    2     // Timing of last REFRESH command to power down entry[tCK] 
  `define     tACTPDEN                    2     // Timing of last ACT command to power down entry[tCK]
  `define     tWLOmax                7500.0     // Write Leveling output delay[ns]
`endif

  `define     tXPR                 120000.0     // tXPR Exit Reset from CKE assertion to a valid command[ns]
  `define     tXPR_TCK                    5     // tXPR Exit Reset from CKE assertion to a valid command[tCK]   


`ifdef x16
  `define lenDQ       16
  `define lenDQS       2
`elsif x8
  `define lenDQ        8
  `define lenDQS       1
`else `define x4  
  `define lenDQ        4
  `define lenDQS       1
`endif
 

// Density
`ifdef DDR3_512Mb
  `define     tRFCmin               90000.0     // auto refresh row cycle time[ns](512Mb)
  `ifdef x16
    `define lenADDR     13
    `define lenROW      12
    `define lenCOL      10
  `elsif x8
    `define lenADDR     13
    `define lenROW      13
    `define lenCOL      10
  `else `define x4
    `define lenADDR     13
    `define lenROW      13
    `define lenCOL      11  
  `endif
`elsif DDR3_1Gb
  `define     tRFCmin              110000.0     // auto refresh row cycle time[ns](1Gb)
  `ifdef x16
    `define lenADDR     13
    `define lenROW      13
    `define lenCOL      10
  `elsif x8
    `define lenADDR     14
    `define lenROW      14
    `define lenCOL      10
  `else `define x4
    `define lenADDR     14
    `define lenROW      14
    `define lenCOL      11  
  `endif
`elsif DDR3_2Gb
  `define     tRFCmin              160000.0     // auto refresh row cycle time[ns](2Gb)
  `ifdef x16
    `define lenADDR     14
    `define lenROW      14
    `define lenCOL      10
  `elsif x8
    `define lenADDR     15
    `define lenROW      15
    `define lenCOL      10
  `else `define x4
    `define lenADDR     15
    `define lenROW      15
    `define lenCOL      11  
  `endif
`elsif DDR3_4Gb
  `define     tRFCmin              300000.0     // auto refresh row cycle time[ns](4Gb)
  `ifdef x16
    `define lenADDR     15
    `define lenROW      15
    `define lenCOL      10
  `elsif x8
    `define lenADDR     16
    `define lenROW      16
    `define lenCOL      10
  `else `define x4
    `define lenADDR     16
    `define lenROW      16
    `define lenCOL      11  
  `endif
`else `define DDR3_8Gb
  `define     tRFCmin              350000.0     // auto refresh row cycle time[ns](8Gb)
  `ifdef x16
    `define lenADDR     16
    `define lenROW      16
    `define lenCOL      10
  `elsif x8
    `define lenADDR     16
    `define lenROW      16
    `define lenCOL      11
  `else `define x4
    `define lenADDR     16
    `define lenROW      16
    `define lenCOL      12  
  `endif
`endif  
